﻿<%@ WebHandler Language="C#" Class="RSS_CS" %>

using System;
using System.Web;
using System.Xml;
using System.Text;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;

public class RSS_CS : IHttpHandler
{
    public void ProcessRequest (HttpContext context) {
        BuildFeedXML(context, 1);
    }

    private void BuildFeedXML(HttpContext context, int channelId)
    {
        using (XmlTextWriter writer = new XmlTextWriter(context.Response.OutputStream, Encoding.UTF8))
        {
            DataTable dt = GetData("SELECT * FROM Channel WHERE Id = @ChannelId", channelId);
            writer.WriteStartDocument();
            writer.WriteStartElement("rss");
            writer.WriteAttributeString("version", "2.0");
            writer.WriteStartElement("channel");
            writer.WriteElementString("title", dt.Rows[0]["Title"].ToString());
            writer.WriteElementString("link", dt.Rows[0]["Link"].ToString());
            writer.WriteElementString("description", dt.Rows[0]["Description"].ToString());
            writer.WriteElementString("copyright", dt.Rows[0]["Copyright"].ToString());

            dt = GetData("SELECT * FROM Feeds WHERE ChannelId = @ChannelId", channelId);
            foreach (DataRow dr in dt.Rows)
            {
                writer.WriteStartElement("item");
                writer.WriteElementString("title", dr["Title"].ToString());
                writer.WriteElementString("description", dr["Description"].ToString());
                writer.WriteElementString("link", dr["Link"].ToString());
                writer.WriteElementString("guid", dr["Id"].ToString());
                writer.WriteElementString("pubDate", Convert.ToDateTime(dr["PublishedDate"]).ToString("R"));
                writer.WriteEndElement();
            }
            writer.WriteEndElement();
            writer.WriteEndElement();
            writer.WriteEndDocument();
            writer.Flush();
            writer.Close();
        }
    }

    private DataTable GetData(string query, int channelId)
    {
        DataTable dt = new DataTable();
        string constr = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
        using (SqlConnection con = new SqlConnection(constr))
        {
            using (SqlCommand cmd = new SqlCommand(query))
            {
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@ChannelId", channelId);
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    sda.Fill(dt);
                }
            }
        }
        return dt;
    }
 
    public bool IsReusable {
        get {
            return false;
        }
    }
}